#!/usr/bin/perl -w

BEGIN {
    use strict 'vars';
    use XML::XPath;
}

sub xpath
{
  my $file = $_[0];
  my $xpstring = $_[1];
  my $xpath;
  my @result = ();
  if ("$file" eq '-') {
    $xpath = XML::XPath->new(ioref => \*STDIN);
  } else {
    $xpath = XML::XPath->new(filename => "$file");
  }
  my $nodes = $xpath->findnodes($xpstring);
  foreach my $node ($nodes->get_nodelist)
  {
    my $str = $node->string_value;
    push @result, $str;
  }
  return @result;
}

sub getfirst
{
  my $res;
  if (scalar(@_) > 0) { $res = $_[0]; } else { $res = ""; }
  return $res;
}

# FIXME
sub pkg_valid
{
  my $x=shift;
#  if ($x=~/([^\/]+)\-(.+)\-([0-9]+)\-(.+)\.tar/)
#  { return 1; } else { return 0; }
  return 1;
}

sub pkg_name
{
  my $file=shift;
  my $ret;
  my @temp;
  system "tar xf $file ./package.box";
  @temp = xpath("package.box",'/box/source/name');
  $ret = getfirst(@temp);
  system "rm -f package.box";
  return $ret;
}

sub pkg_version
{
  my $file=shift;
  my $ret;
  my @temp;
  system "tar xf $file ./package.box";
  @temp = xpath("package.box",'/box/source/name/@version');
  $ret = getfirst(@temp);
  system "rm -f package.box";
  return $ret;
}

# FIXME
sub pkg_release
{
  my $x=shift;
#  return $3 if ($x=~/([^\/]+)\-(.+)\-([0-9]+)\-(.+)\.tar/)
  return "1";
}

# FIXME
sub pkg_type
{
  my $x=shift;
#  return $4 if ($x=~/([^\/]+)\-(.+)\-([0-9]+)\-(.+)\.tar/)
  return "bin";
}

# FIXME
sub pkg_read_changelog
{
  my $file=shift;
#  open(PKG,"tar xfO $file BOX/CHANGELOG|");
#  my @changelog=<PKG>;
#  close(PKG);
#  return @changelog;
  return "FIXME";
}

sub pkg_read_build
{
#  my $file=shift;
#  open(PKG,"tar xfO $file BOX/BUILD|");
#  my @build=<PKG>;
#  close(PKG);
#  return @build;
  return "FIXME";
}

sub pkg_filelist
{
  my $file=shift;
  open(CMD,"box.pl -l $file|");
  @filelist = <CMD>;
  close(CMD);
  return @filelist;
}

END {};

1;

